#!perl
####################################################################################################
# Perl/XML Portfolio Gallery Viewer
# Adam S. Kirschner
# February 4, 2004
#
# Version: 
# This script will read in from an XML file and this Perl script
# will output html in a gallery.
#####################################################################################################
# Modules
#####################################################################################################
use strict;
use warnings;
use CGI;
use HTML::Template;
use Image::Size;

	use constant WEBSITE_PATH => "/usr/local/apache/htdocs";

	my $request = CGI->new();

	pageStart( $request );

	sub pageStart {
		my ( $request ) = @_;
		my ( $height, $width );
		if ( defined( $request->param("h") ) && defined( $request->param("w") ) ) {
			$height = $request->param("h");
			$width = $request->param("w");
		} else {
			( $width, $height ) = get_dimensions( $request->param("p") );
		}

		my $template = HTML::Template->new( loop_context_vars => 1, filename => "../ht_tmpl/blowup.tmpl" );
		
		$template->param( title => $request->param("t"),
			image_src => $request->param("p"),
		);
		
		print "Content-type: text/html\n\n";
		
		print $template->output();
	}

	sub get_dimensions {
		my ( $picture ) = @_;
		my $path_on_system = WEBSITE_PATH . $picture;
		return( imgsize( $path_on_system ) );
	}
1;
