#!perl
####################################################################################################
# Perl/XML Portfolio Image Size Retriever
# Adam S. Kirschner
# February 5, 2004
#
# Version: 
# This script will read in an image file and then print
# out an XML file with it's height and width.
#####################################################################################################
# Modules
#####################################################################################################
use strict;
use warnings;
use CGI;
use HTML::Template;
use Image::Size;

	#use constant WEBSITE_PATH => "/usr/local/apache/htdocs";
	use constant WEBSITE_PATH => "/var/www/kirsch.ivillage.cc/ht_docs";

	my $request = CGI->new();

	pageStart( $request );

	sub pageStart {
		my ( $request ) = @_;
 		my ( $width, $height ) = get_dimensions( $request->param("p") );
		

		my $template = HTML::Template->new( loop_context_vars => 1, filename => "../ht_tmpl/image_dimensions.tmpl" );
		
		$template->param( height => $height,
			width => $width
		);
		
		print "Content-type: text/xml\n\n";
		
		print $template->output();
	}

	sub get_dimensions {
		my ( $picture ) = @_;
		my $path_on_system = WEBSITE_PATH . $picture;
		return( imgsize( $path_on_system ) );
	}
1;
