#!perl
####################################################################################################
# Perl/XML Portfolio Gallery Viewer
# Adam S. Kirschner
# February 4, 2004
#
# Version: 
# This script will read in from an XML file and this Perl script
# will output html in a gallery.
#####################################################################################################
# Modules
#####################################################################################################
use strict;
use warnings;
use XML::Simple;
use CGI;
use HTML::Template;
use Data::Dumper;

	my $request = CGI->new();
	
	pageStart( $request );

sub pageStart {
	my ( $request ) = @_;
	my ( @allGalleries, $startup_image );
	my $template = HTML::Template->new( loop_context_vars => 1, filename => "../ht_tmpl/gallery.tmpl" );
	print "Content-type: text/html\n\n";

	if ( defined( $request->param("g") ) ) {
		
		my $gallery = get_XML_data($request->param("g"));
		my $gallery_count = 0;
		foreach my $sub_gallery ( @{ $gallery->{site} } ) {			
			$gallery_count++;
			my $counter = 0;
			my @aGallery;
			foreach my $picture ( @ {$sub_gallery->{picture} } ) {
				$counter++;				
				$startup_image = $picture if ( $gallery_count == $request->param("a") && $counter == $request->param("i") ) ;
				push @aGallery, {filename => $picture, picture_number => $counter };
			}
			
			push @allGalleries, { name => $sub_gallery->{name}[0], pictures => \@aGallery };
		}
		
		$template->param( startup_image => $startup_image, client => $gallery->{client}[0], gallery => \@allGalleries );
		print $template->output();

	} else {
		print "Error. No Gallery Given";
	}
}

#########################################################################
# Function: 		get_XML_data
# Purpose:		reads in XML data from File
# Returns:		associative array of XML data.
# Outputs: 		nothing
# Parmeters: 
#
#	filename:	the filename of the menu to be drawn
#########################################################################
sub get_XML_data {
	my ( $filename ) = @_;
	my $xml = new XML::Simple;
	my $data =  $xml->XMLin( "$filename.xml", forcearray => 1);
	return $data;
}
