#!perl
####################################################################################################
# Perl/XML Portfolio Gallery Thumbnail Viewer
# Adam S. Kirschner
# February 4, 2004
#
# Version: 
# This script will read in from an XML file and this Perl script
# will output html in a gallery.
#####################################################################################################
# Modules
#####################################################################################################
use strict;
use warnings;
use XML::Simple;
use CGI;
use HTML::Template;
use Data::Dumper;

#########################################################################
# Function: 		get_XML_data
# Purpose:		reads in XML data from File
# Returns:		associative array of XML data.
# Outputs: 		nothing
# Parmeters: 
#
#	filename:	the filename of the menu to be drawn
#########################################################################

	my $request = CGI->new();
	
	pageStart( $request );

sub pageStart {
	my ( $request ) = @_;
	my ( @allGalleries );
	my $template = HTML::Template->new( loop_context_vars => 1, filename => "../ht_tmpl/gallery_thumbs.tmpl" );
	print "Content-type: text/html\n\n";

	if ( defined( $request->param("g") ) ) {
		
		my $gallery = get_XML_data($request->param("g"));
		my $gallery_count = 0;
		foreach my $sub_gallery ( @{ $gallery->{site} } ) {			
			$gallery_count++;
			my $counter = 0;
			my @aGallery;
			my $totalCount = @ { $sub_gallery->{picture} };
			foreach my $picture ( @ {$sub_gallery->{picture} } ) {
				$counter++;				
				my $showbr = 1 if ( $counter % 4 == 0 && $totalCount != $counter );
				push @aGallery, { gallery => $request->param("g"), filename => $picture, album_number => $gallery_count, picture_number => $counter, showbr => $showbr };
			}
			push @allGalleries, { name => $sub_gallery->{name}[0], pictures => \@aGallery };
		}

		$template->param( gallery => \@allGalleries );
		print $template->output();

	} else {
		print "Error. No Gallery Given";
	}
}

sub get_XML_data {
	my ( $filename ) = @_;
	my $xml = new XML::Simple;
	my $data =  $xml->XMLin( "${filename}_thumbs.xml", forcearray => 1);
	return $data;
}
